:h1.English
:p.
This is the documentation for &progver. in english.
.br
Das Folgende ist die Dokumentation fr &progver. in Englisch.

.*-------------------------------------------------------------------------
.*FOLD00.*Introduction
:h2.Introduction
:rm margin=3.

:artwork name='xened.bmp' align=left.
.br

:p.
:hp2.&progver.:ehp2.
:p.
Editor for maps etc. of the famous shoot-'em-up Xenon 2.
:p.
&progname. is a program, that will allow you to edit the sector-maps,
weapon-prices as well as the sector-events (enemies) for all sectors,
thus making it possible to create whole new challenges, make the game
harder for the experienced player or easier to learn for beginners.
:p.
:link reftype=hd refid=eng002.List of changes from v&oldver. to v&newver..
:elink.

.*-------------------------------------------------------------------------
.*FOLD00.*Installation
:h2.Installation
:rm margin=3.
:caution.
First, it should go without saying that you :hp8.make backup-copies of
all your Xenon 2 files and store them in a save place:ehp8. before
using this program! This program will alter most of this files (well,
that's what it was made for, wasn't it?).
:ecaution.
Apart from that, not much to do here. If you have unzipped the files
from the archive and copied them to a directory, you're ready to go.
You can use "install.cmd" to create and setup wps-objects for &progname..

.*-------------------------------------------------------------------------
.*FOLD00.*Command line options
:h2.Command line options
:rm margin=3.
:p.
:hp2.Synopsis&colon.:ehp2. xened [-d xenon2-dir] [-le|-lg] [?|-?|/?|-h]
:p.
:hp2.Here are the valid options&colon.:ehp2.
:parml break=fit tsize=10.
:pt.-d xenon2-dir
:pd.With this switch you can set the Xenon2-directory from the command line.
:pt.-l?

:pd.Select language&colon.
.br
-le   English
.br
-lg   German
:eparml.

:p.? or -? or /? or -h  display a short help-text.

.*-------------------------------------------------------------------------
.*FOLD00.*Editing events
:h2.Editing events
:rm margin=3.
:p.Editing events allows you to change the type, skill and behaviour of the
enemies. As you perhaps may have noticed, the enemies are clustered together
in groups, so the adjustments always will work on a per-group basis, for all
groups in this sector.

:p.MIN and MAX are the minimum and maximum values found currently in this
sector.

:dl break=all tsize=5.
:dt.:hp2.Randomize types:ehp2.
:dd.This will change the type of the enemies, e.g. change those
red tadpoles to those silver saucers things. For every group to be changed, a
type will be randomly chosen from all available types for that sector.
You may set how many of the groups should be changed from 0% (no change) to
100% (change every group). Normally does not affect gameplay very much.

:dt.:hp2.Randomize paths:ehp2.
:dd.This will change the way the enemies fly over the screen. For every group
to be changed, a path will be randomly chosen from all available paths for
that sector (there is only a limited number of them). You may set
how many of the groups should be changed from 0% (no change) to 100% (change
every group). Does affect gameplay, until you get used to the new paths.

:dt.:hp2.Randomize time:ehp2.
:dd.This will change the time when the enemies appear. You may set
how many of the groups should be changed from 0% (no change) to 100% (change
every group). Does heavily affect gameplay, though it depends if for good or
worse.

:dt.:hp2.Firing frequency:ehp2.
:dd.Here you may lower or raise the firing frequency for the enemies. This
can really spoil your game, if you set it too high. But on the other hand,
if you like challenges ... Range&colon. 0-199.

:dt.:hp2.Speed:ehp2.
:dd.Here you may lower or raise the speed for the enemies. Don't set this too
fast ... Range&colon. 1-30.

:dt.:hp2.Number of enemies:ehp2.
:dd.Here you may adjust the number of enemies per group. More enemies mean
more score, but also more work ... and more danger, if the shoot!
Range&colon. 1-40.

:dt.:hp2.Distance:ehp2.
:dd.Here you may adjust the distance between the enemies of a group.
If you set this low, they will cluster together, making it easier to shoot
them. Range&colon. 0-99 and 100-199 (0-99&colon. Enemies will come one after
another with a distance of 0-99 pixel between them. 100-199&colon. Enemies
will appear and move together as one horizontal line with a distance of 0-99
pixel between them; if there are many enemies in a group and the distance
is big, some may never be seen on the screen).

:edl.


.*-------------------------------------------------------------------------
.*FOLD00.*Using the keyboard
:h2.Using the keyboard
:rm margin=3.
:p.
:hp2.Here are the valid keys and what they do&colon.:ehp2.
:parml break=fit tsize=20 compact.
:pt.Tab:pd.Next button (or gadgets, like we used to call them on the
Amiga; Anyone remember Xenon 1? Those were the times ... ;-)
:pt.Shift+Tab:pd.Previous button
:pt.Return, Enter:pd.Select button
:eparml.

:p.
:hp2.MAIN MENU:ehp2.
:parml break=fit tsize=20 compact.
:pt.Down, Tab:pd.Next menu entry
:pt.Up, Shift+Tab:pd.Previous menu entry
:pt.PageUp:pd.First menu entry
:pt.PageDown:pd.Last menu entry
:pt.Return, Enter:pd.Select entry
:eparml.

:p.
:hp2.SECTOR INFO &amp. TRAINER MODE:ehp2.
:parml break=fit tsize=20 compact.
:pt.PageDown, Down:pd.Next page
:pt.PageUp, Up:pd.Previous page
:pt.Esc:pd.Back to main menu
:eparml.

:p.
:hp2.EDIT WEAPON PRICES:ehp2.
:parml break=fit tsize=20 compact.
:pt.'+':pd.Next weapon
:pt.'-':pd.Previous weapon
:pt.PageUp:pd.Price +100
:pt.PageDown:pd.Price -100
:pt.Up:pd.Price +10
:pt.Down:pd.Price -10
:pt.'s':pd.Save prices to XENON2.EXE
:pt.Esc:pd.Back to main menu
:hp8.(If not saved, all changes will be lost!):ehp8.
:eparml.

:p.
:hp2.MAP EDITOR:ehp2.
:parml break=fit tsize=20 compact.
:pt.'+':pd.Next tile
:pt.'-':pd.Previous tile
:pt.Del:pd.Clear mapfield under cursor
:pt.Space:pd.Set mapfield to selected tile
:pt.PageUp:pd.Move map 1 page up
:pt.PageDown:pd.Move map 1 page down
:pt.Cursor keys:pd.Move cursor
:pt.'s':pd.Save map to ...\MAP.CMP
:pt.Esc:pd.Back to main menu
:hp8.(If not saved, all changes will be lost!):ehp8.
:eparml.

.*-------------------------------------------------------------------------
.*FOLD00.*Mouse support
:h2.Mouse support
:rm margin=3.
:p.
Mouse support is something that I really would like to have included.
Unfortunatly this is a bit tricky. So still no mouse support ...

.*FOLD00.*Distributed files
:h2.Distributed files
:rm margin=3.
:p.:hp2.The &progname. distribution contains the following files&colon.:ehp2.
:dl compact tsize=15.
:dt.xened.inf:dd.&progname.-documentation in english and german.
:dt.xened.exe:dd.The program itself.
:dt.xened.ico:dd.Some nice icon, designed in hours of work.
:dt.xendoc.ico:dd.Another nice icon for the &progname. documentation.
:dt.file_id.diz:dd.Short program-description.
:dt.xened.dat:dd.Data for tiles and graphics, etc.
:dt.german.msg:dd.Program messages in german.
:dt.english.msg:dd.Program messages in english.
:dt.install.cmd:dd.REXX-command file for OS/2 to setup workplace shell
objects for &progname. and documentation.
:dt.xened.cfg:dd.Some configuration-data. Created automaticly.
:edl.

.*-------------------------------------------------------------------------
.*FOLD00.*Known Bugs
:h2.Known Bugs
:rm margin=3.
:ul compact.
:li.I don't know why, but sometimes the modified game will just stop. At the
moment I think this happens if too many (> 100 or so) enemies are on the
screen.
:li.Minor aesthetical bug in the "star"-routine (I won't tell you, what
exactly it is, if you don't find out by yourself, it's even smaller
than I thought ;-).
:li."Stars" will stop when message-window is displayed (No, that's not
the bug, although it doesn't look good too ...).
:li.Performance is far from what it could be.
:li.Some more aesthetical bugs.
:eul.

.*-------------------------------------------------------------------------
.*FOLD00.*Changes
:h2 id=eng002.Changes
:rm margin=3.
:p.
:hp2.XENED 1.01 (MS-DOS, OS/2):ehp2.
:ul compact.
:li.Xened is now Free Software under the GPL.
:eul.

:p.
:hp2.XENED 1.00 (MS-DOS, OS/2):ehp2.
:ul compact.
:li.Fixed a small but serious bug, that caused Xened to overwrite MODS.VGA
instead of MAP.CMP.
:li."Randomize time" now should work, though it is still not what I want it to
be.
:li.Fixed a small bug with the saving of a sector's events to EVENTS.PC.
:li.Added min and max values for current sector's in the "edit events" window.
:li.Some additions to the documentation.
:eul.

:p.
:hp2.XENED 0.97.1 (MS-DOS, OS/2, Linux):ehp2.
:ul compact.
:li.Fixed another small bug (where do they all come from? ;-).
:li.Updated my e-Mail &amp. Fidonet adress.
:eul.

:p.
:hp2.XENED 0.97 (MS-DOS, OS/2, Linux):ehp2.
:ul compact.
:li.First release of the Linux version.
:li.added command-line switch "-d" for setting the Xenon 2 directory.
:li.fixed some small bugs (and possibly added some others ;-).
:eul.

:p.
:hp2.XENED 0.96 (MS-DOS, OS/2):ehp2.
:ul compact.
:li.First public release for MS-DOS &amp. OS/2.
:eul.

.*-------------------------------------------------------------------------
.*FOLD00.*Stuff still to do
:h2.Stuff still to do
:rm margin=3.
:ul compact.
:li.Allow editing of background events.
:li.Better editing of events. *
:li.Allow creating/deleting of events (especially bonus-stuff). *
:li.Allow editing (and creating) of the enemies' flying paths. *
:li.Fixing above mentioned bugs.
:eul.
:p.(* I know how to do it, but I haven't had the time to include it)

.*-------------------------------------------------------------------------
.*FOLD00.*Credits & Copyright
:h2.Credits &amp. Copyright
:rm margin=3.
:p.
:hp2.Credits:ehp2.
:p.
LZW-decoding routine Copyright (C) 1987, by Steven A. Bennett
based on code written by Steve Wilhite.
:p.
Timer-routines written or modified between 1988 and 1991 by various
people (all public domain; the code, not the people ;-)&colon.
Fred C. Smith, Dean Pentcheff, Richard S. Sadowsky,
Brian Foley / Kim Kokkonen
:p.
Many thanks to Sascha Weber for his excellent beta testing ... &colon.-)
:p.
.br
:hp2.Copyright:ehp2.
:p.&progname.  Copyright (c) 1995-&lastyear. Thorsten Thielen.

.*-------------------------------------------------------------------------
.*FOLD00.*Status of program
:h2.Status of program
:rm margin=3.
:p.
&progname.  is (apart from the LZW-decoding and timer routines mentioned
above) Free Software under the Gnu General Public License (GPL).
See the file "COPYING" for more info.

:p.
:link reftype=hd refid=eng001.How to contact the author:elink.

.*-------------------------------------------------------------------------
.*FOLD00.*Disclaimer & legal stuff
:h2.Disclaimer &amp. legal stuff
:rm margin=3.
:p.
"I didn't do it! I didn't do it! Butthead did it!" ;-)
:p.
See the file "COPYING" for more info.
:p.
All trademarks mentioned anywhere around here are property of their
owners and the like ...

.*-------------------------------------------------------------------------
.*FOLD00.*Author & Xened homepage
:h2 id=eng001.Author &amp. &progname. homepage
:rm margin=3.
:p.:hp2.Author:ehp2.
:lm margin=5.
:p.
Thorsten Thielen
:parml break=fit tsize=15 compact.
:pt.Internet&colon.:pd.
:font facename=Courier size=16x14.&email1.
:font facename=default size=0x0.
:pt.WWW&colon.:pd.
:font facename=Courier size=16x14.&www.
:font facename=default size=0x0.
:eparml.
:lm margin=1.
:p.
Suggestions and bug-reports are always welcome. Well ... bug-reports
are perhaps not :hp1.that:ehp1. welcome ... ;-)
:p.
.br
:hp2.&progname. homepage:ehp2.
:p.
Visit the &progname. homepage&colon.
:p.
:font facename=Courier size=16x14.&www./xened
:font facename=default size=0x0.
